/* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*          FUNDAMENTOS DA COMPUTAO GRFICA             *
*                     TRABALHO 1                         *
*                                                        *
*  Developed by:                                         *
*              Peter F. Dam                              *
*                                                        *
*  File:                                                 *
*              ColorUtils.h                              *
*                                                        *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef FCG_COLORUTILS
#define FCG_COLORUTILS

#include "Vec3.h"

namespace FCG
{
	class ColorUtils
	{
	public:
		static EPSG::Vec3<double>	xyzbar_to_xyY( const EPSG::Vec3<double>& xyzbar );
		static EPSG::Vec3<double>	xyzbar_to_XYZ( const EPSG::Vec3<double>& xyzbar );
		static EPSG::Vec3<double>	xyzbar_to_RGB( const EPSG::Vec3<double>& xyzbar );
		
		static EPSG::Vec3<double>	xyY_to_XYZ( const EPSG::Vec3<double>& xyY );
		
		static EPSG::Vec3<double>	XYZ_to_RGB( const EPSG::Vec3<double>& XYZ );
		static EPSG::Vec3<double>	RGB_to_XYZ( const EPSG::Vec3<double>& RGB );

		static EPSG::Vec3<double>	XYZ_to_Lab( const EPSG::Vec3<double>& XYZ );

		static double				gammaCorrect( double g );
	};
}

#endif//FCG_COLORUTILS