/* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*          FUNDAMENTOS DA COMPUTAO GRFICA             *
*                     TRABALHO 1                         *
*                                                        *
*  Developed by:                                         *
*              Peter F. Dam                              *
*                                                        *
*  File:                                                 *
*              Geom.h                                    *
*                                                        *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef FCG_GEOM
#define FCG_GEOM

#include "Vec3.h"
#include <vector>

namespace FCG
{
	class Geom
	{
	public:
		/*   [CONSTRUCTOR]   */		Geom();

		int							addVertex( EPSG::Vec3<double> vertex, EPSG::Vec3<double> color );
		void						addTriangle( int v1, int v2, int v3 );
		void						addTriangle( EPSG::Vec3<int> triangle );

		int							countVertex();
		int							countTriangle();

		const EPSG::Vec3<double>&	getVertex( int index );
		const EPSG::Vec3<int>&		getTriangle( int index );

		Geom*						subdivide();

		void						print( const char* file );
		void						printAsMesh( const char* file );

	private:
		std::vector<EPSG::Vec3<double>>	_vertex;
		std::vector<EPSG::Vec3<double>>	_color;
		std::vector<EPSG::Vec3<int>>	_triangle;
	};
}

#endif//FCG_GEOM