#include "Illuminant.h"

using namespace FCG;

Illuminant* Illuminant::s_instance = NULL;

FCG::Illuminant::Illuminant()
{
	_values[D65_2]		= EPSG::Vec3<double>( 95.682,  100.000, 92.149 );
	_values[D65_10]		= EPSG::Vec3<double>( 94.811,  100.000, 107.304 );

	setStandardIlluminant( D65_2 );
}

Illuminant* FCG::Illuminant::instance()
{
	if( s_instance == NULL )
		s_instance = new Illuminant();

	return s_instance;
}

void FCG::Illuminant::setStandardIlluminant( IllType ill )
{
	_standard = ill;
}

EPSG::Vec3<double>& FCG::Illuminant::getStandardIlluminant()
{
	return getIlluminant( _standard );
}

EPSG::Vec3<double>& FCG::Illuminant::getIlluminant( IllType ill )
{
	return _values.find( ill )->second;
}