/* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*          FUNDAMENTOS DA COMPUTAO GRFICA             *
*                     TRABALHO 1                         *
*                                                        *
*  Developed by:                                         *
*              Peter F. Dam                              *
*                                                        *
*  File:                                                 *
*              Illuminant.h                              *
*                                                        *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef FCG_ILLUMINANT
#define FCG_ILLUMINANT

#include "Vec3.h"
#include <map>

namespace FCG
{
	class Illuminant
	{
		enum IllType
		{
			D65_2,
			D65_10
		};

	public:
		static Illuminant*			instance();

		void						setStandardIlluminant( IllType ill );

		EPSG::Vec3<double>&			getStandardIlluminant();
		EPSG::Vec3<double>&			getIlluminant( IllType ill );

	private:
		/*   [CONSTRUCTOR]   */		Illuminant();

		IllType						_standard;

		typedef std::map<IllType, EPSG::Vec3<double>>	ValueMap;
		ValueMap					_values;

		static Illuminant*			s_instance;
	};
}

#endif//FCG_ILLUMINANT