#include "Vec3.h"
#include "Geom.h"
#include "Spectrum.h"
#include "FileUtils.h"
#include "ColorUtils.h"

void fcg_t1_1();
void fcg_t1_2();

void main( void )
{
	fcg_t1_1();
	fcg_t1_2(); 
}

void fcg_t1_1()
{
	///////// [TRABALHO 1 FCG - PARTE 1] \\\\\\\\\
	// Entrada de dados de espectro
	FILE* fData = FCG::FileUtils::openFile( "../data/spectrum.txt", "rt" );

	FCG::Spectrum* s = new FCG::Spectrum();
	int nm;
	double x, y, z;
	while( fscanf_s( fData, "%d%lf%lf%lf", &nm, &x, &y, &z ) > 0 )
		s->addValue( nm, x, y, z );

	fclose( fData );

	EPSG::Vec3<double> pWhiteRGB( 1, 1, 1 );
	EPSG::Vec3<double> pBlackRGB( 0, 0, 0 );


	// Construo da geometria XYZ com as cores espectrais puras
	EPSG::Vec3<double> pWhiteXYZ = FCG::ColorUtils::RGB_to_XYZ( pWhiteRGB );
	EPSG::Vec3<double> pBlackXYZ = FCG::ColorUtils::RGB_to_XYZ( pBlackRGB );

	FCG::Geom* xyz = new FCG::Geom();
	xyz->addVertex( pWhiteXYZ, pWhiteRGB );
	xyz->addVertex( pBlackXYZ, pBlackRGB );

	for( int i = s->first() + 60; i < s->first() + s->size() - 165; i++ )
	{
		EPSG::Vec3<double> tmpXYZ = FCG::ColorUtils::xyzbar_to_XYZ( *(s->getValue( i )) );
		xyz->addVertex( tmpXYZ, FCG::ColorUtils::XYZ_to_RGB( tmpXYZ ) );
	}

	for( int i = 0; i < xyz->countVertex() - 3; i++ )
	{
		xyz->addTriangle( 0, i + 2, i + 3 );
		xyz->addTriangle( 1, i + 2, i + 3 );
	}
	xyz->addTriangle( 0, xyz->countVertex() - 1, 2 );
	xyz->addTriangle( 1, xyz->countVertex() - 1, 2 );

	xyz->print( "../output/FCG_T1_1_XYZ.txt" );
	xyz->printAsMesh( "../output/FCG_T1_1_XYZ-MESH.txt" );


	// Construo da geometria Lab com as cores espectrais puras
	FCG::Geom* lab = new FCG::Geom();
	lab->addVertex( FCG::ColorUtils::XYZ_to_Lab( pWhiteXYZ ), pWhiteRGB );
	lab->addVertex( FCG::ColorUtils::XYZ_to_Lab( pBlackXYZ ), pBlackRGB );

	for( int i = s->first() + 60; i < s->first() + s->size() - 165; i++ )
	{
		EPSG::Vec3<double> tmpXYZ = FCG::ColorUtils::xyzbar_to_XYZ( *(s->getValue( i )) );
		EPSG::Vec3<double> tmpLab = FCG::ColorUtils::XYZ_to_Lab( tmpXYZ );
		lab->addVertex( tmpLab, FCG::ColorUtils::XYZ_to_RGB( tmpXYZ ) );
	}

	for( int i = 0; i < lab->countVertex() - 3; i++ )
	{
		lab->addTriangle( 0, i + 2, i + 3 );
		lab->addTriangle( 1, i + 2, i + 3 );
	}
	lab->addTriangle( 0, lab->countVertex() - 1, 2 );
	lab->addTriangle( 1, lab->countVertex() - 1, 2 );

	lab->print( "../output/FCG_T1_1_Lab.txt" );
	lab->printAsMesh( "../output/FCG_T1_1_Lab-MESH.txt" );


	// Construo da geometria sRGB com as cores espectrais puras
	FCG::Geom* rgb = new FCG::Geom();
	rgb->addVertex( pWhiteRGB, pWhiteRGB );
	rgb->addVertex( pBlackRGB, pBlackRGB );

	for( int i = s->first() + 60; i < s->first() + s->size() - 165; i++ )
	{
		EPSG::Vec3<double> tmpXYZ = FCG::ColorUtils::xyzbar_to_XYZ( *(s->getValue( i )) );
		EPSG::Vec3<double> tmpRGB = FCG::ColorUtils::XYZ_to_RGB( tmpXYZ );
		rgb->addVertex( tmpRGB, tmpRGB );
	}

	for( int i = 0; i < rgb->countVertex() - 3; i++ )
	{
		rgb->addTriangle( 0, i + 2, i + 3 );
		rgb->addTriangle( 1, i + 2, i + 3 );
	}
	rgb->addTriangle( 0, rgb->countVertex() - 1, 2 );
	rgb->addTriangle( 1, rgb->countVertex() - 1, 2 );

	rgb->print( "../output/FCG_T1_1_sRGB.txt" );
	rgb->printAsMesh( "../output/FCG_T1_1_sRGB-MESH.txt" );
}

void fcg_t1_2()
{
	///////// [TRABALHO 1 FCG - PARTE 2] \\\\\\\\\
	// Construo do cubo sRGB
	FCG::Geom* rgb = new FCG::Geom();
	rgb->addVertex( EPSG::Vec3<double>( 0, 0, 0 ), EPSG::Vec3<double>( 0, 0, 0 ) );
	rgb->addVertex( EPSG::Vec3<double>( 1, 0, 0 ), EPSG::Vec3<double>( 1, 0, 0 ) );
	rgb->addVertex( EPSG::Vec3<double>( 1, 1, 0 ), EPSG::Vec3<double>( 1, 1, 0 ) );
	rgb->addVertex( EPSG::Vec3<double>( 0, 1, 0 ), EPSG::Vec3<double>( 0, 1, 0 ) );
	rgb->addVertex( EPSG::Vec3<double>( 0, 0, 1 ), EPSG::Vec3<double>( 0, 0, 1 ) );
	rgb->addVertex( EPSG::Vec3<double>( 1, 0, 1 ), EPSG::Vec3<double>( 1, 0, 1 ) );
	rgb->addVertex( EPSG::Vec3<double>( 1, 1, 1 ), EPSG::Vec3<double>( 1, 1, 1 ) );
	rgb->addVertex( EPSG::Vec3<double>( 0, 1, 1 ), EPSG::Vec3<double>( 0, 1, 1 ) );
	rgb->addTriangle( 0, 3, 2 );
	rgb->addTriangle( 0, 2, 1 );
	rgb->addTriangle( 0, 4, 7 );
	rgb->addTriangle( 0, 7, 3 );
	rgb->addTriangle( 0, 1, 5 );
	rgb->addTriangle( 0, 5, 4 );
	rgb->addTriangle( 6, 7, 4 );
	rgb->addTriangle( 6, 4, 5 );
	rgb->addTriangle( 6, 2, 3 );
	rgb->addTriangle( 6, 3, 7 );
	rgb->addTriangle( 6, 5, 1 );
	rgb->addTriangle( 6, 1, 2 );
	rgb = rgb->subdivide();
	rgb = rgb->subdivide();

	rgb->print( "../output/FCG_T1_2_sRGB.txt" );
	rgb->printAsMesh( "../output/FCG_T1_2_sRGB-MESH.txt" );


	// Construo da geometria XYZ com as cores sRGB
	FCG::Geom* xyz = new FCG::Geom();
	for( int i = 0; i < rgb->countVertex(); i++ )
	{
		EPSG::Vec3<double> tmpXYZ = FCG::ColorUtils::RGB_to_XYZ( rgb->getVertex(i) );
		xyz->addVertex( tmpXYZ, rgb->getVertex(i) );
	}

	for( int i = 0; i < rgb->countTriangle(); i++ )
		xyz->addTriangle( rgb->getTriangle(i) );

	xyz->print( "../output/FCG_T1_2_XYZ.txt" );
	xyz->printAsMesh( "../output/FCG_T1_2_XYZ-MESH.txt" );


	// Construo da geometria Lab com as cores sRGB
	FCG::Geom* lab = new FCG::Geom();
	for( int i = 0; i < xyz->countVertex(); i++ )
	{
		EPSG::Vec3<double> tmpLab = FCG::ColorUtils::XYZ_to_Lab( xyz->getVertex(i) );
		lab->addVertex( tmpLab, rgb->getVertex(i) );
	}

	for( int i = 0; i < xyz->countTriangle(); i++ )
		lab->addTriangle( xyz->getTriangle(i) );

	lab->print( "../output/FCG_T1_2_Lab.txt" );
	lab->printAsMesh( "../output/FCG_T1_2_Lab-MESH.txt" );
}