#include "Spectrum.h"

#include <stdio.h>

using namespace FCG;

Spectrum::Spectrum()
{
}

void Spectrum::addValue( int wavelength, double x, double y, double z )
{
	addValue( wavelength, EPSG::Vec3<double>( x, y, z ) );
}

void Spectrum::addValue( int wavelength, EPSG::Vec3<double> v )
{
	_values[wavelength] = v;
}

const EPSG::Vec3<double>* Spectrum::getValue( int wavelength )
{
	ValueMap::iterator i = _values.find( wavelength );
	if( i == _values.end() )
		return new EPSG::Vec3<double>( 0, 0, 0 );

	return &(i->second);
}

int FCG::Spectrum::size()
{
	return (int)_values.size();
}

int FCG::Spectrum::first()
{
	ValueMap::iterator i = _values.begin();
	return i->first;
}