/* * * * * * * * * * * * * * * * * * * * * * * * * * * * *
*          FUNDAMENTOS DA COMPUTAO GRFICA             *
*                     TRABALHO 1                         *
*                                                        *
*  Developed by:                                         *
*              Peter F. Dam                              *
*                                                        *
*  File:                                                 *
*              Spectrum.h                                *
*                                                        *
* * * * * * * * * * * * * * * * * * * * * * * * * * * * */

#ifndef FCG_SPECTRUM
#define FCG_SPECTRUM

#include "Vec3.h"
#include <map>

namespace FCG
{
	class Spectrum
	{
	public:
		/*   [CONSTRUCTOR]   */		Spectrum();

		void						addValue( int wavelength, double x, double y, double z );
		void						addValue( int wavelength, EPSG::Vec3<double> v );
		const EPSG::Vec3<double>*	getValue( int wavelength );

		int							size();
		int							first();

	private:
		typedef std::map<int, EPSG::Vec3<double>>	ValueMap;
		ValueMap					_values;
	};
}

#endif//FCG_SPECTRUM